using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using System.Linq;
using UnityEngine.SceneManagement;

namespace AcidSea
{
    public class AcidSea
    {
        public static void OnLoad()
        {
            Map AcidSeaa = ScriptableObject.CreateInstance<Map>();
            AcidSeaa.name = "Acid Sea";
            AcidSeaa.UniqueIdentity = Guid.NewGuid().ToString();
            AcidSeaa.Description = "Acidic sea?";
            AcidSeaa.Thumbnail = ModAPI.LoadSprite("Thumb.png");
            AcidSeaa.Preview = ModAPI.LoadSprite("Thumb.png");
            AcidSeaa.Prefab = MapRegistry.GetAllMaps().ElementAt(6).Prefab;
            MapRegistry.Register(AcidSeaa);
        }



        public static void Main()
        {
            var ds = ModAPI.FindSpawnable("Discord01");
            if (ds == null)
            {
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Rod"),
                        NameOverride = "Discord01",
                        DescriptionOverride = "Discord 01-Studio",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("discord.png"),
                        AfterSpawn = (Instance) =>
                        {
                            Utils.OpenURL("https://discord.gg/WngbXBckQ4");
                            GameObject.Destroy(Instance);
                        }
                    }
                );
            }
            ModAPI.Register<OnLoadMap>();
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Acid SeAaa",
                    DescriptionOverride = "SPAWNED ONLY ON SEA MAP ! ! !",
                    CategoryOverride = ModAPI.FindCategory(""),
                    ThumbnailOverride = ModAPI.LoadSprite("sprite.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<AcidWater>();
                    }
                }
            );


        }
        public class AcidWater : MonoBehaviour
        {

            public GameObject sea;
            public bool isMapSea = false;
            void Start()
            {
                foreach (GameObject gameObject in UnityEngine.Object.FindObjectsOfType<GameObject>())
                {
                    Component[] components = GetComponents<Component>();
                    var obj = gameObject.name;
                    if (gameObject.name == "Ocean map(Clone)")
                    {
                        isMapSea = true;
                    }
                }
                if (isMapSea == true)
                {
                    foreach (GameObject gameObject in UnityEngine.Object.FindObjectsOfType<GameObject>())
                    {
                        Component[] components = GetComponents<Component>();
                        var obj = gameObject.name;
                        if (gameObject.name == "Sea")
                        {
                            if (gameObject.GetComponent<AcidWaterEffect>() == null)
                            {
                                //gameObject.GetComponent<SpriteRenderer>().sprite = null;
                                sea = gameObject;
                                // water color//
                                GameObject seaGameObject = GameObject.Find("WORLD/MAP/Ocean map(Clone)/Root/Sea");
                                SpriteRenderer spriteRenderer = seaGameObject.GetComponent<SpriteRenderer>();
                                spriteRenderer.sharedMaterial.shader = Shader.Find("Sprites/Default");
                                spriteRenderer.material.color = new Color(0, 1f, 0.1509f, 0.1819f);
                                spriteRenderer.color = new Color(0, 1, 0, 1);
                                // water color//
                                sea.AddComponent<AcidWaterEffect>();
                                AcidWaterEffect.AcidGo = true;

                                //GameObject.Destroy(gameObject);
                            }
                            else
                            {
                                ModAPI.Notify("The acid is already in the water!");
                                //GameObject.Destroy(gameObject);
                            }
                        }
                    }
                }
                if (isMapSea == false)
                {
                    ModAPI.Notify("You can't use this object not on the Sea map!");
                }
                GameObject.Destroy(gameObject);
            }
        }
        public class AcidWaterEffect : MonoBehaviour
        {
            public static bool AcidGo = false;
            void Update()
            {
                if (AcidGo == true)
                {
                    foreach (GameObject gameObject in UnityEngine.Object.FindObjectsOfType<GameObject>())
                    {
                        if (gameObject.GetComponent<PersonBehaviour>() != null)
                        {
                            if (gameObject.GetComponent<AcidWaterForHuman>() == null)
                            {
                                gameObject.AddComponent<AcidWaterForHuman>();
                            }
                        }
                    }
                }
            }
            void OnDestroy()
            {
                var a = UnityEngine.GameObject.Instantiate(ModAPI.FindSpawnable("Acid SeAaa").Prefab);
                a.AddComponent<AcidWater>();
            }
        }
        public class AcidWaterForHuman : MonoBehaviour
        {
            public PersonBehaviour pr;
            public LimbBehaviour lm;
            public PhysicalBehaviour[] ph;
            void Start()
            {
                pr = gameObject.GetComponent<PersonBehaviour>();
                for (int i = 0; i < pr.Limbs.Length; i++)
                {
                    pr.Limbs[i].gameObject.AddComponent<AcidWaterForLimb>();
                }

                //ph = lm.PhysicalBehaviour;
            }
        }
        public class AcidWaterForLimb : MonoBehaviour
        {
            public LimbBehaviour limb;
            public PhysicalBehaviour physical;
            void Start()
            {
                limb = gameObject.GetComponent<LimbBehaviour>();
                physical = limb.PhysicalBehaviour;
            }
            void Update()
            {
                if (physical.IsUnderWater == true)
                {
                    limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("ACID"), 0.05f * Time.deltaTime);
                }
            }
        }
        public class OnLoadMap : MonoBehaviour
        {
            Transform Root;
            void Start()
            {
                if (MapLoaderBehaviour.CurrentMap.name == "Acid Sea")
                {
                    Root = GameObject.Find("Root").transform;
                    var a = UnityEngine.GameObject.Instantiate(ModAPI.FindSpawnable("Acid SeAaa").Prefab);
                    a.AddComponent<AcidWater>();

                }
            }
        }
    }
}
